<?php
/* 
Description: Code for TBD
 
Copyright 2014 Malcolm Shergold

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

if (!class_exists('StageShowLibJQueryTrolley')) 
{
	include 'stageshowlib_nonce.php';
	include 'stageshowlib_dbase_base.php';
	
	if (!defined('STAGESHOWLIB_FILENAME_JQUERYCALLLOG'))
		define('STAGESHOWLIB_FILENAME_JQUERYCALLLOG', 'JQueryCallLog.txt');
		
	class StageShowLibJQueryTrolley
	{
		function __construct($cartObjClassName)
		{
			$atts = array();
			
			$cartObj = new $cartObjClassName(__FILE__);
			
			if (!isset($this->myDomain)) $this->myDomain = 'stageshowlib';
			
			$myDBaseObj = $cartObj->myDBaseObj;
			
			if ($myDBaseObj->IsPageCached())
			{
				echo '<div id="message" class="'.$this->myDomain.'-error error">jQuery Call Error: Box Office Page is Cached<br>
				Update Cache Settings or Disable Caching
				</div>';
				exit;				
			}

			if (!$myDBaseObj->SessionVarsAvailable())
			{
				echo '<div id="message" class="'.$this->myDomain.'-error error">jQuery Call Error: Session Variables not available</div>';
				exit;
			}
			
			if ($myDBaseObj->isDbgOptionSet('Dev_ShowGET'))
			{
				StageShowLibUtilsClass::print_r($_GET, '$_GET');
			}
			if ($myDBaseObj->isDbgOptionSet('Dev_ShowPOST'))
			{
				StageShowLibUtilsClass::print_r($_POST, '$_POST');
			}		
			if ($myDBaseObj->isDbgOptionSet('Dev_ShowSESSION'))
			{
				StageShowLibUtilsClass::print_r($_SESSION, '$_SESSION');
			}	
				
			$logCallToFile = $myDBaseObj->getDbgOption('Dev_LogJQueryCalls');
			$logCall = $logCallToFile || isset($_SESSION['stageshowlib_debug_trolley']);
			
			$stringToHash = '';
        	$ourNOnce = StageShowLibNonce::GetStageShowLibNonceEx(STAGESHOWLIB_UPDATETROLLEY_TARGET, $stringToHash);
        	
			if ($logCall)
			{
				if ($logCallToFile)
				{
					include 'stageshowlib_logfile.php';
					$LogsFolder = $myDBaseObj->getOption('LogsFolderPath').'/';
					$logFileObj = new StageShowLibLogFileClass($LogsFolder);
				}
				
				$logEntry = StageShowLibUtilsClass::print_r($_POST, 'JQuery Call-$_POST', true);
				$logEntry .= "stringToHash: $stringToHash \n";
				$logEntry .= "Expected NOnce: $ourNOnce \n";
			}
			
			if (!isset($_POST['_wpnonce']) || ($_POST['_wpnonce'] != $ourNOnce))
			{
				if ($logCall)
				{
					if ($logCallToFile)
					{
						$logFileObj->StampedLogToFile(STAGESHOWLIB_FILENAME_JQUERYCALLLOG, $logEntry, StageShowLibDBaseClass::ForAppending);
					}
					else
					{
						echo $logEntry;
					}
				}
				die;
			}		
			
			if (isset($_POST['count']))			
			{
				$cartObj->shortcodeCount = $_POST['count'];
			}			

			$atts = array();
			$scattMarker = 'scatt_';
			$scattMarkerLen = strlen($scattMarker);
			foreach ($_POST as $key => $val)
			{
				if (substr($key, 0, $scattMarkerLen) == $scattMarker)
				{
					$key = substr($key, $scattMarkerLen);
					$atts[$key] = $val;
				}
			}
			 		
			ob_start();
			$divId = $cartObj->cssTrolleyBaseID.'-trolley-jquery';			
			$hiddenDivStyle  = 'style="display: none;"';
			$trolleyDiv = "<div id=$divId name=$divId $hiddenDivStyle >\n";	
			$endDiv = '</div>'."\n";
				
			$hasActiveTrolley = $cartObj->Cart_OnlineStore_HandleTrolley();
			$trolleyContent = ob_get_contents();
			ob_end_clean();

			ob_start();
			$cartObj->Cart_OutputContent_OnlineStoreMain($atts);
			$uiOut = $cartObj->OutputContent_OnlineTrolleyUserInterface();
			
			if ($cartObj->boxofficeContent == '')
			{
				$cartObj->boxofficeContent = ob_get_contents();
			}
			ob_end_clean();		
			
			if ($hasActiveTrolley) $trolleyContent .= $uiOut;
			else if ($cartObj->storeRows > 0) $cartObj->boxofficeContent .= $uiOut;
			
			$trolleyContent = $trolleyDiv.$trolleyContent.$endDiv;
			
			$trolleyContent = apply_filters($this->myDomain.'_filter_trolley', $trolleyContent);
			$cartObj->boxofficeContent = apply_filters($this->myDomain.'_filter_boxoffice', $cartObj->boxofficeContent);
			
			if ($myDBaseObj->getOption('ProductsAfterTrolley'))
			{
				$outputContent = $trolleyContent.$cartObj->boxofficeContent;
			}
			else
			{
				$outputContent = $cartObj->boxofficeContent.$trolleyContent;
			}
			
			if ($logCall)
			{
				if ($logCallToFile)
				{
					$logEntry .= $outputContent;
					$logFileObj->StampedLogToFile(STAGESHOWLIB_FILENAME_JQUERYCALLLOG, $logEntry, StageShowLibDBaseClass::ForAppending);
				}
				else
				{
					echo $logEntry;
				}
			}
			
			echo $outputContent;
		}
	}
}

?>